﻿
namespace SmartMenu.Classes
{
    public class MenuItemInfo
    {
        private int _MenuItemId;
        /// <summary>
        /// Unique id of the menu item
        /// </summary>
        public int MenuItemId
        {
            get
            {
                return _MenuItemId;
            }
            set
            {
                _MenuItemId = value;
            }
        }

        private int _MenuId;
        /// <summary>
        /// Id of the menu this menu item is part of
        /// </summary>
        public int MenuId
        {
            get
            {
                return _MenuId;
            }
            set
            {
                _MenuId = value;
            }
        }

        private int _ParentId;
        /// <summary>
        /// Parent menu item id of the menu item
        /// </summary>
        public int ParentId
        {
            get
            {
                return _ParentId;
            }
            set
            {
                _ParentId = value;
            }
        }

        private string _Title;
        /// <summary>
        /// Title of the menu item
        /// </summary>
        public string Title
        {
            get
            {
                return _Title;
            }
            set
            {
                _Title = value;
            }
        }

        private string _Url;
        /// <summary>
        /// Url of the menu item
        /// </summary>
        public string Url
        {
            get
            {
                return _Url;
            }
            set
            {
                _Url = value;
            }
        }

        private int _Order;
        /// <summary>
        /// Order of the menu item
        /// </summary>
        public int Order
        {
            get
            {
                return _Order;
            }
            set
            {
                _Order = value;
            }
        }

        private bool _Visible;
        /// <summary>
        /// Menu item is visible or not
        /// </summary>
        public bool Visible
        {
            get
            {
                return _Visible;
            }
            set
            {
                _Visible = value;
            }
        }
        private string _Image;
        /// <summary>
        /// Menu item Image
        /// </summary>
        public string Image
        {
            get
            {
                return _Image;
            }
            set
            {
                _Image = value;
            }
        }
    }
}
