﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace viBlog.Classes
{
    /// <summary>
    /// Represents a blog post
    /// </summary>
    public class Post
    {
        private int _PostId;
        /// <summary>
        /// The unique ri of the Post
        /// </summary>
        public int PostId
        {
            get { return _PostId; }
            set { _PostId = value; }
        }
        private string _Title;
        /// <summary>
        /// Title of the Post
        /// </summary>
        public string Title
        {
            get { return _Title; }
            set { _Title = value; }
        }
        private string _Author;
        /// <summary>
        /// Author of the Post
        /// </summary>
        public string Author
        {
            get { return _Author; }
            set { _Author = value; }
        }
        private DateTime _Date;
        /// <summary>
        /// Date Created
        /// </summary>
        public DateTime Date
        {
            get { return _Date; }
            set { _Date = value; }
        }

        private string _Summary;
        /// <summary>
        /// Post Contents
        /// </summary>
        public string Summary
        {
            get { return _Summary; }
            set { _Summary = value; }
        }

        private string _Url;
        /// <summary>
        /// Url for the Post
        /// </summary>
        public string Url
        {
            get { return _Url; }
            set { _Url = value; }
        }

        private bool _AllowComments;
        /// <summary>
        /// Allow comments for the post
        /// </summary>
        public bool AllowComments
        {
            get { return _AllowComments; }
            set { _AllowComments = value; }
        }
        
        private bool _IsDraft;
        /// <summary>
        /// This is a post or a draft
        /// </summary>
        public bool IsDraft
        {
            get { return _IsDraft; }
            set { _IsDraft = value; }
        }
    }
}
