﻿using System;

namespace viNews.Classes
{
    /// <summary>
    /// The news is like an article or a post
    /// which viNews can display on the webpage in variety of ways
    /// </summary>
    public class News
    {
        private int _NewsId;
        private string _Title;
        private DateTime _Date;
        private int _Category;
        private string _ImageUrl;
        private string _Author;
        private string _Summary;
        private bool _Publish;
        private string _Url;


        /// <summary>
        /// The unique news id
        /// </summary>
        public int NewsId
        {
            get
            {
                return _NewsId;
            }
            set
            {
                _NewsId = value;
            }
        }

        /// <summary>
        /// Title of the news
        /// </summary>
        public string Title
        {
            get
            {
                return _Title;
            }
            set
            {
                _Title = value;
            }
        }

        /// <summary>
        /// The date of the news
        /// </summary>
        public DateTime Date
        {
            get
            {
                return _Date;
            }
            set
            {
                _Date = value;
            }
        }

        /// <summary>
        /// The category of the news
        /// </summary>
        public int Category
        {
            get
            {
                return _Category;
            }
            set
            {
                _Category = value;
            }
        }

        /// <summary>
        /// The image associated with the news
        /// </summary>
        public string ImageUrl
        {
            get
            {
                return _ImageUrl;
            }
            set
            {
                _ImageUrl = value;
            }
        }

        /// <summary>
        /// The author of the news
        /// </summary>
        public string Author
        {
            get
            {
                return _Author;
            }
            set
            {
                _Author = value;
            }
        }

        /// <summary>
        /// Summary of the news
        /// </summary>
        public string Summary
        {
            get
            {
                return _Summary;
            }
            set
            {
                _Summary = value;
            }
        }

        /// <summary>
        /// Wether this news is published
        /// </summary>
        public bool Publish
        {
            get
            {
                return _Publish;
            }
            set
            {
                _Publish = value;
            }
        }

        /// <summary>
        /// The url of the news
        /// </summary>
        public string Url
        {
            get
            {
                return _Url;
            }
            set
            {
                _Url = value;
            }
        }
    }
}
