﻿
namespace visinia.SmartEngine.Installer
{
    /// <summary>
    /// Every visinia module must be registered to the data store
    /// ModuleInstalled class represents that data structure
    /// </summary>
    public class ModuleInstalled
    {
        private int _ModuleInstalledId;
        /// <summary>
        /// The unique Id of the Installed Module
        /// </summary>
        public int ModuleInstalledId
        {
            get { return _ModuleInstalledId; }
            set { _ModuleInstalledId = value; }
        }
        private string _Package;
        /// <summary>
        /// The package name this module is part of
        /// </summary>
        public string Package
        {
            get { return _Package; }
            set { _Package = value; }
        }
        private string _Name;
        /// <summary>
        /// The Actual name of the Installed Module
        /// </summary>
        public string Name
        {
            get { return _Name; }
            set { _Name = value; }
        }
        private string _ModuleUrl;
        /// <summary>
        /// Gets or Sets the module actual ascx file path
        /// </summary>
        public string ModuleUrl
        {
            get { return _ModuleUrl; }
            set { _ModuleUrl = value; }
        }
        private string _ModuleSettingsUrl;
        /// <summary>
        /// Gets or Sets the module's setting ascx file path
        /// </summary>
        public string ModuleSettingsUrl
        {
            get { return _ModuleSettingsUrl; }
            set { _ModuleSettingsUrl = value; }
        }
        private string _Icon;
        /// <summary>
        /// The module icon shown in module repository
        /// </summary>
        public string Icon
        {
            get { return _Icon; }
            set { _Icon = value; }
        }
        private string _Image;
        /// <summary>
        /// The module image
        /// </summary>
        public string Image
        {
            get { return _Image; }
            set { _Image = value; }
        }
        private string _Help;
        /// <summary>
        /// The module help
        /// </summary>
        public string Help
        {
            get { return _Help; }
            set { _Help = value; }
        }
    }    
}
