﻿
using System.Collections;
namespace visinia.SmartEngine.Modules
{
    /// <summary>
    /// visinia modules can have their specific settings
    /// for those settings a module requires a user interface.
    /// To solve this problem a module can have a UserControl
    /// which has all the controls which are required for its
    /// private settings form.
    /// That UserControl must be derived from WebSettingsModule.
    /// This also adds the support to share the settings among 
    /// the actual module and module settings UserControl
    /// </summary>
    public abstract class WebSettingsModule : BaseModule
    {
        #region Overrides
        /// <summary>
        /// Override to save module specific settings
        /// This is actually called when user saves the module
        /// standard settings.
        /// </summary>
        /// <param name="data">The data is name value pairs of the
        /// actual data which is sent from the module settings dialog</param>
        public virtual void SaveSettings(Hashtable data) { }
        #endregion
    }
}
