﻿using System;

namespace visinia.SmartEngine.SiteMap
{
    public class SiteMapInfo
    {
        public enum ChangeFreq
        {
            /// <summary>
            /// The source contents change daily
            /// </summary>
            Daily,
            /// <summary>
            /// The source contents change monthly
            /// </summary>
            Monthly
        }

        public SiteMapInfo(string plugin, string title, string url, DateTime lastModified, ChangeFreq changeFrequency)
        {
            _Plugin = plugin;
            _Title = title;
            _Url = url;
            _LastModified = lastModified;
            _ChangeFrequency = changeFrequency;
        }

        private string _Plugin;
        /// <summary>
        /// The plugin name
        /// </summary>
        public string Plugin
        {
            get
            {
                return _Plugin;
            }
            set
            {
                _Plugin = value;
            }
        }

        private string _Title;
        /// <summary>
        /// The title
        /// </summary>
        public string Title
        {
            get
            {
                return _Title;
            }
            set
            {
                _Title = value;
            }
        }

        private string _Url;
        /// <summary>
        /// The url
        /// </summary>
        public string Url
        {
            get
            {
                return _Url;
            }
            set
            {
                _Url = value;
            }
        }

        private DateTime _LastModified;
        /// <summary>
        /// The last modified date
        /// </summary>
        public DateTime LastModified
        {
            get
            {
                return _LastModified;
            }
            set
            {
                _LastModified = value;
            }
        }

        private ChangeFreq _ChangeFrequency;
        /// <summary>
        /// The Change Frequency
        /// </summary>
        public ChangeFreq ChangeFrequency
        {
            get
            {
                return _ChangeFrequency;
            }
            set
            {
                _ChangeFrequency = value;
            }
        }
    }
}
