﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="CustomErrorPageZ.ascx.cs"
    Inherits="Admin_Pages_ErrorPageZ_CustomErrorPageZ" %>
<div class="admin-form">
    <h1>
        Custom Error Pages Settings
    </h1>
    <div class="admin-box">
        <h2>
            Mode</h2>
        <asp:DropDownList ID="CUSTOM_ERRORS_MODES" runat="server">
            <asp:ListItem>On</asp:ListItem>
            <asp:ListItem>Off</asp:ListItem>
            <asp:ListItem>RemoteOnly</asp:ListItem>
        </asp:DropDownList>
        <asp:Button CssClass="button important" ID="UpdateMode" runat="server" Text="Update Mode"
            OnClick="UpdateMode_Click" />
        <asp:Button CssClass="button" ID="CANCEL" runat="server" Text="Cancel" OnClick="CANCEL_Click" />
    </div>
    <div class="admin-box data-table">
        <h2>
            Default Redirect</h2>
        <table>
            <tbody>
                <tr>
                    <th>
                        Name
                    </th>
                    <th>
                        Description
                    </th>
                    <th>
                        Set
                    </th>
                    <th>
                        Set
                    </th>
                    <th>
                        Reset
                    </th>
                    <th>
                        DesignPage
                    </th>
                </tr>
                <tr>
                    <td>
                        defaultRedirect
                    </td>
                    <td>
                        <p>
                            Specifies the default URL to direct a browser to, if an error occurs. When this
                            attribute is not specified, a generic error is displayed instead.</p>
                    </td>
                    <td>
                        <asp:CheckBox ID="CheckBoxDefaultRedirect" Enabled="false" runat="server" />
                    </td>
                    <td>
                        <asp:LinkButton ID="SetDefaultRedirect" runat="server" OnClick="SetDefaultRedirect_Click">Set</asp:LinkButton>
                    </td>
                    <td>
                        <asp:LinkButton ID="ResetDefaultRedirect" CssClass="delete" runat="server" OnClick="ResetDefaultRedirect_Click">Reset</asp:LinkButton>
                    </td>
                    <td>
                        <asp:LinkButton ID="DesignDefaultRedirect" runat="server" OnClick="DesignDefaultRedirect_Click">Design</asp:LinkButton>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
    <div class="admin-box data-table">
        <h2>
            Custom Error Pages</h2>
        <asp:GridView ID="CustomErrorPages" runat="server" AutoGenerateColumns="False" DataSourceID="ObjectDataSourceCustomErrorPages"
            OnRowCommand="CustomErrorPages_RowCommand" GridLines="None">
            <Columns>
                <asp:BoundField DataField="statusCode" HeaderText="statusCode" SortExpression="statusCode" />
                <asp:BoundField DataField="Name" HeaderText="Name" SortExpression="Name" />
                <asp:BoundField DataField="Description" HeaderText="Description" SortExpression="Description" />
                <asp:CheckBoxField DataField="Set" HeaderText="Set" SortExpression="Set" />
                <asp:ButtonField CommandName="SetErrorPage" HeaderText="Set" Text="Set" />
                <asp:ButtonField CommandName="ResetErrorPage" HeaderText="Reset" ControlStyle-CssClass="delete" Text="Reset" />
                <asp:ButtonField CommandName="DesignPage" HeaderText="DesignPage" Text="Design" />
            </Columns>
        </asp:GridView>
        <asp:ObjectDataSource ID="ObjectDataSourceCustomErrorPages" runat="server" SelectMethod="StatusCodes"
            TypeName="ErrorPageZ.Controllers.StatusCodesController"></asp:ObjectDataSource>
    </div>
</div>
