﻿using System;
using System.IO;
using visinia.SmartEngine;

namespace visinia.web.admin.pages
{
    public partial class UploadImage : System.Web.UI.UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
                Populate(Server.MapPath(WebRoots.GetResourcesRoot));
        }

        protected void UPLOAD_Click(object sender, EventArgs e)
        {
            string destination = Directories.SelectedValue;
            AddImage(destination);
        }

        private void AddImage(string folder)
        {
            string path = Server.MapPath(WebRoots.GetResourcesRoot);
            if (folder != "\\")
                path += folder + "\\";
            if (MediaFile.HasFile)
                MediaFile.SaveAs(ResolveDuplicate(path, MediaFile.FileName));
        }

        private string ResolveDuplicate(string folder, string filename)
        {
            string path = folder + filename;
            if (System.IO.File.Exists(path))
            {
                int index = filename.LastIndexOf('.');
                string name = filename.Substring(0, index);
                string extension = filename.Substring(index);
                int counter = 1;
                while (System.IO.File.Exists(path))
                {
                    path = folder + name + counter.ToString() + extension;
                    counter++;
                }
            }
            return path;
        }

        protected void CANCEL_Click(object sender, EventArgs e)
        {
            Response.Redirect(Request.RawUrl);
        }

        private void Populate(string path)
        {
            DirectoryInfo dir = new DirectoryInfo(path);
            if (dir.Exists)
            {
                Directories.Items.Add("\\");
                GetDirectories(dir.GetDirectories(), dir.FullName);
            }
        }

        private void GetDirectories(DirectoryInfo[] subDirs, string path)
        {
            foreach (DirectoryInfo subDir in subDirs)
            {
                if ((subDir.Attributes & FileAttributes.Hidden) == FileAttributes.Hidden)
                    continue;
                DirectoryInfo[] subSubDirs;
                Directories.Items.Add(subDir.FullName.Substring(path.Length));
                subSubDirs = subDir.GetDirectories();
                if (subSubDirs.Length != 0)
                {
                    GetDirectories(subSubDirs, path);
                }
            }
        }
    }
}