﻿<%@ Control Language="C#" AutoEventWireup="true" CodeFile="AddUser.ascx.cs" Inherits="visinia.web.admin.pages.AddUser" %>
<div class="admin-form">
    <h1>
        <%= Resources.translation.AddNewUser%></h1>
    <div class="admin-box">
        <h2>
            <%= Resources.translation.AddNewUser%></h2>
        <asp:CreateUserWizard ID="CreateUserWizard1" runat="server" OnCreatingUser="CreateUserWizard1_CreatingUser" LoginCreatedUser="False">
            <CreateUserButtonStyle CssClass="button important" />
            <WizardSteps>
                <asp:CreateUserWizardStep ID="CreateUserWizardStep1" runat="server">
                    <ContentTemplate>
                        <asp:Label CssClass="label" ID="UserNameLabel" runat="server" AssociatedControlID="UserName"> 
                            <%= Resources.translation.Name%></asp:Label>
                        <asp:TextBox ID="UserName" runat="server"></asp:TextBox>
                        
                            <asp:RequiredFieldValidator ID="UserNameRequired" runat="server" ControlToValidate="UserName"
                                ErrorMessage="User Name is required." ToolTip="User Name is required." ValidationGroup="CreateUserWizard1">*</asp:RequiredFieldValidator>
                        
                        <asp:Label CssClass="label"  ID="PasswordLabel" runat="server" AssociatedControlID="Password"><%= Resources.translation.Password%></asp:Label>
                        <asp:TextBox ID="Password" runat="server" TextMode="Password"></asp:TextBox>
                        
                            <asp:RequiredFieldValidator ID="PasswordRequired" runat="server" ControlToValidate="Password"
                                ErrorMessage="Password is required." ToolTip="Password is required." ValidationGroup="CreateUserWizard1">*</asp:RequiredFieldValidator>
                        
                        <asp:Label CssClass="label"  ID="ConfirmPasswordLabel" runat="server" AssociatedControlID="ConfirmPassword"><%= Resources.translation.ConfirmPassword%></asp:Label>
                        <asp:TextBox ID="ConfirmPassword" runat="server" TextMode="Password"></asp:TextBox>
                        
                            <asp:RequiredFieldValidator ID="ConfirmPasswordRequired" runat="server" ControlToValidate="ConfirmPassword"
                                ErrorMessage="Confirm Password is required." ToolTip="Confirm Password is required."
                                ValidationGroup="CreateUserWizard1">*</asp:RequiredFieldValidator>
                       
                        <asp:Label CssClass="label"  ID="EmailLabel" runat="server" AssociatedControlID="Email"><%= Resources.translation.email%></asp:Label>
                        <asp:TextBox ID="Email" runat="server"></asp:TextBox>
                        
                            <asp:RequiredFieldValidator ID="EmailRequired" runat="server" ControlToValidate="Email"
                                ErrorMessage="E-mail is required." ToolTip="E-mail is required." ValidationGroup="CreateUserWizard1">*</asp:RequiredFieldValidator>
                       
                        <asp:CompareValidator ID="PasswordCompare" runat="server" ControlToCompare="Password"
                            ControlToValidate="ConfirmPassword" Display="Dynamic" ErrorMessage="The Password and Confirmation Password must match."
                            ValidationGroup="CreateUserWizard1"></asp:CompareValidator>
                        <asp:Literal ID="ErrorMessage" runat="server" EnableViewState="False"></asp:Literal>
                    </ContentTemplate>
                </asp:CreateUserWizardStep>
                <asp:CompleteWizardStep ID="CompleteWizardStep1" runat="server">
                </asp:CompleteWizardStep>
            </WizardSteps>
        </asp:CreateUserWizard>
        </div>
        <div class="admin-box" visible="false">        
        <asp:Label ID="ERROR" runat="server" ForeColor="Red"></asp:Label>
    </div>
</div>
