﻿using System;
using System.Collections;
using viNews.Classes;
using viNews.Controllers;
using visinia.SmartEngine;

public partial class Admin_Pages_viNews_DataFilters_DataFilters : System.Web.UI.UserControl
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Request.QueryString["ModuleId"] == null)
            return;
        WebPageController.AddScriptLink(Page, WebRoots.GetAdminPagesRoot + "viNews/DataFilters/DataFilters.js");
        if (!IsPostBack)
        {
            int ModuleId = Convert.ToInt32(Request.QueryString["ModuleId"]);
            DataFilter filter = DataFilterController.GetFilter(ModuleId);
            if (filter == null)
            {
                int count = 0; // a default value
                COUNT.Value = count.ToString();
                return;
            }
            else
            {
                int temp = 0;
                switch (filter.FilterType)
                {
                    case DataFilterController.FILTER.LATEST_BY_DATE:
                        Filters.SelectedValue = "viNewsDF_LATEST";
                        break;
                    case DataFilterController.FILTER.LATEST_BY_CATEGORY:
                        Filters.SelectedValue = "viNewsDF_CATEGORY";
                        if (Int32.TryParse(filter.Data, out temp))
                            CATEGORY.CategoryId = temp; ;
                        break;
                    case DataFilterController.FILTER.LATEST_BY_TAG:
                        Filters.SelectedValue = "viNewsDF_TAGS";
                        TAGS.SelectedValue = filter.Data;
                        break;
                    case DataFilterController.FILTER.NEWS_LIST:
                        Filters.SelectedValue = "viNewsDF_NEWS_LIST";
                        NEWS_LIST.Value = filter.Data;
                        break;
                }
                COUNT.Value = filter.ItemsCount.ToString();
            }
        }
    }

    public void SaveFilterData(Hashtable settings)
    {
        string selCOUNT = (string)settings["viNewsDF_COUNT"];
        string selFILTER = (string)settings["viNewsDF_FILTERS"];
        string tempCATEGORY = (string)settings["viNewsDF_CATEGORY"];
        string selTAGS = (string)settings["viNewsDF_TAGS"];
        string selNEWS_LIST = (string)settings["viNewsDF_NEWS_LIST"];

        string selCATEGORY = "";
        if (string.IsNullOrEmpty(tempCATEGORY))
            selCATEGORY = "-1";
        else
        {
            string[] str = tempCATEGORY.Split(',');
            if (Convert.ToInt32(str[1]) == 0)
                selCATEGORY = str[0]; // Parent Only
            else
                selCATEGORY = str[1];// Child Only
        }

        int ModuleId = Convert.ToInt32(settings["MODULE_ID"]);
        DataFilter filter = DataFilterController.GetFilter(ModuleId);
        if (filter == null)
        {// create a new filter
            filter = new DataFilter();
            filter.ModuleId = ModuleId;
            int temp = 0;
            if (Int32.TryParse(selCOUNT, out temp))
                filter.ItemsCount = temp;
            if (selFILTER == "viNewsDF_LATEST")// show latest news
                filter.FilterType = DataFilterController.FILTER.LATEST_BY_DATE;
            else if (selFILTER == "viNewsDF_CATEGORY")//show latest by categories
            {
                filter.FilterType = DataFilterController.FILTER.LATEST_BY_CATEGORY;
                filter.Data = selCATEGORY;
            }
            else if (selFILTER == "viNewsDF_TAGS")//show latest by tags
            {
                filter.FilterType = DataFilterController.FILTER.LATEST_BY_TAG;
                filter.Data = selTAGS;
            }
            else if (selFILTER == "viNewsDF_NEWS_LIST")//show news spedified in the list
            {
                filter.FilterType = DataFilterController.FILTER.NEWS_LIST;
                filter.Data = selNEWS_LIST;
            }
            DataFilterController.AddFilter(filter);
        }
        else
        {// update already existing filter
            int temp = 0;
            if (Int32.TryParse(selCOUNT, out temp))
                filter.ItemsCount = temp;

            if (selFILTER == "viNewsDF_LATEST")// show latest news
                filter.FilterType = DataFilterController.FILTER.LATEST_BY_DATE;
            else if (selFILTER == "viNewsDF_CATEGORY")//show latest by categories
            {
                filter.FilterType = DataFilterController.FILTER.LATEST_BY_CATEGORY;
                filter.Data = selCATEGORY;
            }
            else if (selFILTER == "viNewsDF_TAGS")//show latest by tags
            {
                filter.FilterType = DataFilterController.FILTER.LATEST_BY_TAG;
                filter.Data = selTAGS;
            }
            else if (selFILTER == "viNewsDF_NEWS_LIST")//show news spedified in the list
            {
                filter.FilterType = DataFilterController.FILTER.NEWS_LIST;
                filter.Data = selNEWS_LIST;
            }
            DataFilterController.UpdateFilter(filter);
        }
    }
}
